//+------------------------------------------------------------------+
//|                                                        first.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"

#include <ExpertAdvisor.mqh>

int counter = 0;
input int dealslimit = 10;

int    SL        =  50; //  
int    TP        = 100; //  
int    TS        =  50; //   
double Risk      = 0.1; // 
double lot       = 0.1;
datetime t1,t2;

bool   workstate = true; //  : /
bool   EST;              // EventSetTimer result
int    h1,m1     = 0;
double marginreq = 0;     //  
MqlTick last_tick;        //     
double lastt;

//---
class CMyEA : public CExpertAdvisor
  {
protected:
   double            m_risk;          //  
   int               m_sl;            // 
   int               m_tp;            // 
   int               m_ts;            // 
public:
   void              CMyEA();
   void             ~CMyEA();
   virtual bool      Init(string smb,ENUM_TIMEFRAMES tf); // 
   virtual bool      Main();                              //  
   virtual void      OpenPosition(long dir);              //    
  };
//------------------------------------------------------------------	CMyEA
void CMyEA::CMyEA() { }
//------------------------------------------------------------------	~CMyEA
void CMyEA::~CMyEA()
  {
//   IndicatorRelease(m_hma);   //   
//   IndicatorRelease(m_hbb);//   Bollinger Bands
  }
//------------------------------------------------------------------	Init
bool CMyEA::Init(string smb,ENUM_TIMEFRAMES tf)
  {
   if(!CExpertAdvisor::Init(0,smb,tf)) return(false);                                //   

   //  
   m_risk=Risk; 
   m_tp=TP; 
   m_sl=SL; 
   m_ts=TS;                                           
   m_bInit=true; 
   return(true);                                                                     // " "
  }
//------------------------------------------------------------------	Main
bool CMyEA::Main() //  
  {
//   if(!CExpertAdvisor::Main()) return(false); //    
Print(counter);
   long dir;
   dir=ORDER_TYPE_BUY;
   OpenPosition(dir);
   return(true);
  }
//------------------------------------------------------------------	OpenPos
void CMyEA::OpenPosition(long dir)
  {
   lot = 0.1;
   if(SymbolInfoTick(m_smb,last_tick))
     { 
        lastt = last_tick.ask;
     }
   else
      {  lastt = 1.0;
         Print("SymbolInfoTick() failed, error = ",GetLastError());
      }
//---

   if (OrderCalcMargin(ORDER_TYPE_BUY,m_smb,lot,last_tick.ask,marginreq))

   {
      if (marginreq < AccountInfoDouble(ACCOUNT_FREEMARGIN))
      DealOpen(dir,lot,m_sl,m_tp);
   }
  }

//------------------------------------------------------------------	OnInit

CMyEA ea; //  

int OnInit()
  {
   t1 = TimeLocal();
   EST = EventSetTimer(3600);
   if (!EST) {
     Comment("Error: EventSetTimer= ", GetLastError());
     Print("Error: EventSetTimer= ", GetLastError());
   }
   Print("dealslimit=",dealslimit);
     {
      ea.Init(Symbol(),PERIOD_M1); //  
     }
   return(0);
  }
//------------------------------------------------------------------	OnDeinit
void OnDeinit(const int reason)
  {
   EventKillTimer();
   Print("dealslimit=",dealslimit);
   t2 = TimeLocal();
   Print("Seconds=",t2-t1);
  }
//------------------------------------------------------------------	OnTick
void OnTick()
  {
//  counter++;
  if (counter < dealslimit)
  {
   ea.Main(); //   
  }
  counter++;
  }
 
//------------------------------------------------------------------	OnTrade
void OnTrade()
  {
   workstate = true;   //    
  }

void OnTimer()
  {
   workstate = true;   //    
  }
